net.sf.saxon.expr.instruct

## Class ProcessingInstruction

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.instruct.Instruction
    - - net.sf.saxon.expr.instruct.SimpleNodeConstructor
      - - net.sf.saxon.expr.instruct.ProcessingInstruction

- All Implemented Interfaces:
    Serializable, SourceLocator, LocationProvider, SaxonLocator, TailCallReturner, InstructionInfo, Locator

      public class ProcessingInstruction
      extends SimpleNodeConstructor

  An xsl:processing-instruction element in the stylesheet, or a processing-instruction constructor in a query
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.expr.instruct.SimpleNodeConstructor

      `select`

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, INHERITED_CONTEXT, INSPECTION_CONTEXT, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, NAVIGATION_CONTEXT, NODE_VALUE_CONTEXT, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, W3C_CONSUMING, W3C_FREE_RANGING, W3C_GROUP_CONSUMING, W3C_MOTIONLESS, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ProcessingInstruction(Expression name)` Create an xsl:processing-instruction instruction

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected String` | `checkContent(String data, XPathContext context)` Check the content of the node, and adjust it if necessary
    `static String` | `checkContentXQuery(String data)` Check the content of the node, and adjust it if necessary, using the XQuery rules
    `static String` | `checkContentXSLT(String data)` Check the content of the node, and adjust it if necessary, using the XSLT rules
    `Expression` | `copy()` Copy an expression.
    `NodeName` | `evaluateNodeName(XPathContext context)` Run-time method to compute the name of the node being constructed.
    `void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
    `int` | `getCardinality()` Determine the static cardinality of the expression.
    `int` | `getDependencies()` Determine which aspects of the context the expression depends on.
    `ExpressionCompiler` | `getExpressionCompiler()` Return the compiler of the ProcessingInstruction expression
    `int` | `getInstructionNameCode()` Get the name of this instruction for diagnostic and tracing purposes
    `ItemType` | `getItemType(TypeHierarchy th)` Get the item type of the items returned by evaluating this instruction
    `Expression` | `getNameExpression()` Get the expression that defines the processing instruction name
    `Iterator<SubExpressionInfo>` | `iterateSubExpressionInfo()` Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression.
    `Iterator<Expression>` | `iterateSubExpressions()` Get the immediate sub-expressions of this expression.
    `void` | `localTypeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Method to perform type-checking specific to the kind of instruction
    `void` | `processValue(CharSequence value, XPathContext context)` Process the value of the node, to create the new node.
    `protected void` | `promoteInst(PromotionOffer offer)` Offer promotion for subexpressions.
    `boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
    `Expression` | `simplify(ExpressionVisitor visitor)` Simplify an expression.

    - ### Methods inherited from class net.sf.saxon.expr.instruct.SimpleNodeConstructor

      `computeCardinality, computeSpecialProperties, createsNewNodes, evaluateItem, getContentExpression, getStreamingAdjunct, iterate, optimize, processLeavingTail, setSelect, typeCheck`

    - ### Methods inherited from class net.sf.saxon.expr.instruct.Instruction

      `assembleParams, assembleTunnelParams, dynamicError, evaluateAsString, getConstructType, getExpressionName, getImplementationMethod, getInstructionName, getIteratorFromProcessMethod, getSourceLocator, isXSLT, process, promote`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluatePendingUpdates, explain, getColumnNumber, getColumnNumber, getContainer, getEvaluationMethod, getExecutable, getHostLanguage, getIntegerBounds, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getStreamability, getSystemId, getSystemId, hasVariableBinding, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterateEvents, markTailFunctionCalls, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, toPattern, toStreamingPattern, toString, typeError`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface javax.xml.transform.SourceLocator

      `getColumnNumber, getLineNumber, getPublicId, getSystemId`

- - ### Constructor Detail

    - #### ProcessingInstruction

          public ProcessingInstruction(Expression name)

      Create an xsl:processing-instruction instruction
      Parameters:
        `name` - the expression used to compute the name of the generated processing-instruction

  - ### Method Detail

    - #### getInstructionNameCode

          public int getInstructionNameCode()

      Get the name of this instruction for diagnostic and tracing purposes
      Overrides:
        `getInstructionNameCode` in class `Instruction`
      Returns:
        the string "xsl:processing-instruction"

    - #### getNameExpression

          public Expression getNameExpression()

      Get the expression that defines the processing instruction name
      Returns:
        the expression that defines the processing instruction name

    - #### getItemType

          public ItemType getItemType(TypeHierarchy th)

      Description copied from class: `Instruction`
      Get the item type of the items returned by evaluating this instruction
      Overrides:
        `getItemType` in class `Instruction`
      Parameters:
        `th` - the type hierarchy cache
      Returns:
        the static item type of the instruction

    - #### getCardinality

          public int getCardinality()

      Description copied from class: `Expression`
      Determine the static cardinality of the expression. This establishes how many items there will be in the result of the expression, at compile time (i.e., without actually evaluating the result.
      Overrides:
        `getCardinality` in class `Expression`
      Returns:
        one of the values Cardinality.ONE_OR_MORE, Cardinality.ZERO_OR_MORE, Cardinality.EXACTLY_ONE, Cardinality.ZERO_OR_ONE, Cardinality.EMPTY. This default implementation returns ZERO_OR_MORE (which effectively gives no information).

    - #### simplify

          public Expression simplify(ExpressionVisitor visitor)
                              throws XPathException

      Description copied from class: `Instruction`
      Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression). The default implementation does nothing.
      Overrides:
        `simplify` in class `SimpleNodeConstructor`
      Parameters:
        `visitor` - an expression visitor
      Returns:
        the simplified expression
      Throws:
        `XPathException` - if an error is discovered during expression rewriting

    - #### copy

          public Expression copy()

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Returns:
        the copy of the original expression

    - #### localTypeCheck

          public void localTypeCheck(ExpressionVisitor visitor,
                            ExpressionVisitor.ContextItemType contextItemType)
                              throws XPathException

      Description copied from class: `SimpleNodeConstructor`
      Method to perform type-checking specific to the kind of instruction
      Specified by:
        `localTypeCheck` in class `SimpleNodeConstructor`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of the context item
      Throws:
        `XPathException` - if a type error is detected

    - #### getDependencies

          public int getDependencies()

      Description copied from class: `Expression`
      Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE. The default implementation combines the intrinsic dependencies of this expression with the dependencies of the subexpressions, computed recursively. This is overridden for expressions such as FilterExpression where a subexpression's dependencies are not necessarily inherited by the parent expression.
      Overrides:
        `getDependencies` in class `Expression`
      Returns:
        a set of bit-significant flags identifying the dependencies of the expression

    - #### iterateSubExpressions

          public Iterator<Expression> iterateSubExpressions()

      Description copied from class: `Expression`
      Get the immediate sub-expressions of this expression. Default implementation returns a zero-length array, appropriate for an expression that has no sub-expressions.
      Overrides:
        `iterateSubExpressions` in class `SimpleNodeConstructor`
      Returns:
        an iterator containing the sub-expressions of this expression

    - #### iterateSubExpressionInfo

          public Iterator<SubExpressionInfo> iterateSubExpressionInfo()

      Description copied from class: `SimpleNodeConstructor`
      Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression. Default implementation returns a zero-length array, appropriate for an expression that has no sub-expressions.
      Overrides:
        `iterateSubExpressionInfo` in class `SimpleNodeConstructor`
      Returns:
        an iterator containing the sub-expressions of this expression

    - #### replaceSubExpression

          public boolean replaceSubExpression(Expression original,
                                     Expression replacement)

      Replace one subexpression by a replacement subexpression
      Overrides:
        `replaceSubExpression` in class `SimpleNodeConstructor`
      Parameters:
        `original` - the original subexpression
        `replacement` - the replacement subexpression
      Returns:
        true if the original subexpression is found

    - #### promoteInst

          protected void promoteInst(PromotionOffer offer)
                              throws XPathException

      Offer promotion for subexpressions. The offer will be accepted if the subexpression is not dependent on the factors (e.g. the context item) identified in the PromotionOffer. By default the offer is not accepted - this is appropriate in the case of simple expressions such as constant values and variable references where promotion would give no performance advantage. This method is always called at compile time.
      Overrides:
        `promoteInst` in class `SimpleNodeConstructor`
      Parameters:
        `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
      Throws:
        `XPathException` - if any error is detected

    - #### processValue

          public void processValue(CharSequence value,
                          XPathContext context)
                            throws XPathException

      Process the value of the node, to create the new node.
      Specified by:
        `processValue` in class `SimpleNodeConstructor`
      Parameters:
        `value` - the string value of the new node
        `context` - the dynamic evaluation context
      Throws:
        `XPathException`

    - #### checkContent

          protected String checkContent(String data,
                            XPathContext context)
                                 throws XPathException

      Check the content of the node, and adjust it if necessary
      Overrides:
        `checkContent` in class `SimpleNodeConstructor`
      Parameters:
        `data` - the supplied content
        `context` - the dynamic context
      Returns:
        the original content, unless adjustments are needed
      Throws:
        `XPathException` - if the content is invalid

    - #### checkContentXSLT

          public static String checkContentXSLT(String data)

      Check the content of the node, and adjust it if necessary, using the XSLT rules
      Parameters:
        `data` - the supplied content
      Returns:
        the original content, unless adjustments are needed

    - #### checkContentXQuery

          public static String checkContentXQuery(String data)
                                           throws XPathException

      Check the content of the node, and adjust it if necessary, using the XQuery rules
      Parameters:
        `data` - the supplied content
      Returns:
        the original content, unless adjustments are needed
      Throws:
        `XPathException` - if the content is invalid

    - #### evaluateNodeName

          public NodeName evaluateNodeName(XPathContext context)
                                    throws XPathException

      Description copied from class: `SimpleNodeConstructor`
      Run-time method to compute the name of the node being constructed. This is overridden for nodes that have a name. The default implementation returns -1, which is suitable for unnamed nodes such as comments
      Overrides:
        `evaluateNodeName` in class `SimpleNodeConstructor`
      Parameters:
        `context` - the XPath dynamic evaluation context
      Returns:
        the name pool nameCode identifying the name of the constructed node
      Throws:
        `XPathException` - if any failure occurs

    - #### getExpressionCompiler

          public ExpressionCompiler getExpressionCompiler()

      Return the compiler of the ProcessingInstruction expression
      Overrides:
        `getExpressionCompiler` in class `Expression`
      Returns:
        the relevant ExpressionCompiler

    - #### explain

          public void explain(ExpressionPresenter out)

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `explain` in class `Expression`
      Parameters:
        `out` - the expression presenter used to display the structure

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.